package fr.uca.iut.clfreville2.teaiswarm

import android.os.Bundle
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.RecyclerView
import fr.uca.iut.clfreville2.teaiswarm.model.RepositoryIdentifier
import fr.uca.iut.clfreville2.teaiswarm.network.GiteaService
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch

class RepositoryDetailActivity : AppCompatActivity() {

    private val service = GiteaService()
    private lateinit var repositoryName: TextView
    private lateinit var versionedFiles: RecyclerView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_repository_detail)

        repositoryName = findViewById(R.id.repository_detail_name)

        var currentRepositoryOwner: String? = null
        var currentRepositoryName: String? = null
        val bundle: Bundle? = intent.extras
        if (bundle != null) {
            currentRepositoryOwner = bundle.getString(REPOSITORY_OWNER)
            currentRepositoryName = bundle.getString(REPOSITORY_NAME)
        }

        currentRepositoryName?.let {
            repositoryName.text = currentRepositoryName
        }

        versionedFiles = findViewById(R.id.versioned_files_view)
        lifecycleScope.launch(Dispatchers.IO) {
            val repos = service.listFileContents(RepositoryIdentifier(currentRepositoryOwner!!, currentRepositoryName!!), "")
            lifecycleScope.launch {
                versionedFiles.adapter = FileListAdapter(repos) {}
            }
        }
    }
}
