package fr.uca.iut.clfreville2.teaiswarm.network

import fr.uca.iut.clfreville2.teaiswarm.model.Owner
import fr.uca.iut.clfreville2.teaiswarm.model.Repository
import fr.uca.iut.clfreville2.teaiswarm.model.RepositoryIdentifiable
import fr.uca.iut.clfreville2.teaiswarm.model.VersionedFile

class StubRepositoryService : RepositoryService {

    override suspend fun listActiveRepositories(username: String, page: Int): List<Repository> =
        when (page) {
            1 -> listOf(
                "oki",
                "moshell",
                "scrabble-with-numbers",
                "vdn-tools",
                "codefirst-test",
                "iut-config",
                "Ebullition"
            )
            2 -> listOf(
                "api-ef",
                "codefirst-docdeployer",
                "TeaIsWarm",
                "Application",
                "silex"
            )
            else -> listOf()
        }.map { Repository(Owner(-1, ""), it) }

    override suspend fun listFileContents(repository: RepositoryIdentifiable, filePath: String) =
        listOf(
            "cli",
            "doc",
            "sql",
            "test",
            "web",
            ".drone.yml",
            ".gitignore",
            "CONVENTIONS.md",
            "README.md"
        ).map { VersionedFile(it) }
}
